
(** Stub for template 
    @author Sylvain Le Gall
  *)

open XHTML.M

let css_ocamlcore_org = 
  "
  /*
   *
   * Common theme to all ocamlcore.org websites
   *
   */

  html, body {
  /*	background-color: #5a0b00;*/
    background: #de9453;
  }

  body {
    width: 960px;
    margin-top: 0px;
    margin-left: auto;
    margin-right: auto;
  }

  div#ocamlcore_header {
    height: 65px;
    background: #925a41;
    padding-top: 20px;
    border-left: solid 2px #925a41;
    border-right: solid 2px #925a41;
  }

  div#ocamlcore_header span#title {
    font-size: 40px;
    font-weight: bold;
    padding-left: 64px;
    padding-top: 15px;
    padding-bottom: 15px;
    background: url(https://static.ocamlcore.org/official/images/logo-big.png) no-repeat;
    vertical-align: center;
    color: white;
  }

  div#ocamlcore_content {
    background-color: white;
    padding: 5px;
    border: solid 2px #925a41;
  }

  a:link 
  { 
    text-decoration:none; 
    color: #be000d; 
  }

  a:visited 
  { 
    text-decoration:none; 
    color: #be000d; 
  }

  a:active 
  { 
    text-decoration:none 
  }

  a:hover 
  { 
    text-decoration:underline; 
    color:red 
  }

  pre
  {
    display: block;
    margin: 0.5em;
    padding: 0.5em;
    border: solid 1px #cccccc;
    background-color: #f8f8f8;
    color: #222222;
  }

  div#ocamlcore_footer
  {
    border: solid 2px #925a41;
    background-color: white;
    padding: 3px;
    margin:  10px;
    margin-left: 0px;
    margin-right: 0px;
    height: 60px;
    font-weight: normal;
    font-size: 14px;
    font-family: sans-serif;
  }

  div#ocamlcore_footer div
  {
    margin: 0px;
    padding: 0px;
  }

  div#ocamlcore_footer ul
  {
    position: relative;
    float: left;
    list-style: none;
    margin: 0px;
    margin-top: 10px;
    padding: 0px;
  }

  div#ocamlcore_footer ul li
  {
    list-style: none;
    padding: 3px;
    margin-left: 20px;
    margin-top: 0px;
    margin-bottom: 0px;
  }

  div#ocamlcore_footer .ocamlcore_links
  {
    font-weight: bold;
  }

  div#ocamlcore_footer div.ocamlcore_use ul
  { 
    margin-top: 10px;
    margin-left: 2em;
  }

  div#ocamlcore_footer div.ocamlcore_use ul li
  {
    display: inline;
    padding-left: 0.3em;
  }

  div#ocamlcore_footer .ocamlcore_sponsor
  {
    text-align: left;
    float: right;
  }

  div#ocamlcore_footer div.ocamlcore_sponsor ul
  {
    position: static;
    float: none;
    margin: 0px;
    padding: 0px;
  }
  div#ocamlcore_footer div.ocamlcore_sponsor ul li
  {
    margin: 0px;
    padding-left: 0em;
  }

  div#ocamlcore_footer div.ocamlcore_sponsor p
  {
    margin: 0px;
    padding: 0px;
  }

  div#ocamlcore_footer div.ocamlcore_sponsor img
  {
    border: none;
  }"

let make_page ~website_title ~page_title extra_head content =
  let div_id id ctnt = 
     div 
       ~a:[a_id id]
       ctnt
  in
  let a href ttl = 
    XHTML.M.a
      ~a:[a_href (uri_of_string href)]
      [pcdata ttl]
  in

    html
      (head
         (title (pcdata page_title))
         ((style 
             ~contenttype:"text/css"
             [pcdata css_ocamlcore_org])
         :: extra_head))
      (body 
         [
           div_id "ocamlcore_header"
             [span ~a:[a_id "title"] [pcdata website_title]];

           div_id "ocamlcore_content"
             content;

           div_id "ocamlcore_footer"
             [
               div 
                 ~a:[a_class ["ocamlcore_site"]]
                 [
                   ul
                     ~a:[a_class ["ocamlcore_links"]]
                     (li 
                        [a "http://planet.ocamlcore.org" "Planet"])
                     [li
                        [a "http://forge.ocamlcore.org" "Forge"]];

                   ul
                     ~a:[a_class ["ocamlcore_feedback"]]
                     (li
                        [a
                           "https://forge.ocamlcore.org/tracker/?atid=101&amp;group_id=1&amp;func=browse"
                           "Report a bug"])
                     [li
                        [a
                           "https://forge.ocamlcore.org/tracker/?atid=102&amp;group_id=1&amp;func=browse"
                           "Ask a feature"]];

                   ul
                     ~a:[a_class ["ocamlcore_legal"]]
                     (li
                        [a
                           "http://www.ocamlcore.org/terms_of_use/"
                           "Terms of use"])
                     [li
                        [a
                           "http://www.ocamlcore.org/philosophy/"
                           "Philosophy"]];
                   
                   div 
                     ~a:[a_class ["ocamlcore_use"]]
                     [
                       ul
                         (li
                            [XHTML.M.a
                               ~a:[a_href (uri_of_string "http://caml.inria.fr/")]
                               [
                                 img
                                   ~a:[a_style "border: none;"]
                                   ~src:(uri_of_string 
                                           "https://static.ocamlcore.org/official/images/caml.80x30.gif")
                                   ~alt:"The Caml Language"
                                   ()
                               ]])
                         [(* TODO: ocsigen *)]
                     ];

                   div 
                     ~a:[a_class ["ocamlcore_sponsor"]]
                     [
                       p [pcdata "Sponsors: "];
                       ul
                         (li
                            [XHTML.M.a
                               ~a:[a_href (uri_of_string "http://www.ocamlcore.com");
                                   a_class ["logo"]]
                               [
                                 img
                                   ~src:(uri_of_string
                                           "https://static.ocamlcore.org/official/\
                                            sponsors/ocamlcore/logo-footer.png")
                                   ~alt:"OCamlCore logo"
                                  ()
                               ]])
                         []
                     ]
                 ]
             ]
         ])

let make_page_stub ~page_title extra_head content = 
  make_page
    ~website_title:"OCamlCore.org API"
    ~page_title
    extra_head
    content

